/*
 * Counts words in text.
 */

import java.awt.*;
import java.awt.event.*;
import java.awt.AWTEvent;
import java.applet.*;

import java.io.*;
import java.awt.datatransfer.*;
import java.util.*;

public class WordCountApplet extends Applet {
	private Label countLabel;
	private TextField countTextField;
	private TextArea textArea;
	private String inputString;

	public void init() {
		setLayout(null);	// absolute positioning

		/* Create a text area with */
		textArea = new TextArea(3, 20);
		textArea.setFont(new Font("TimesRoman", Font.BOLD, 14));
		textArea.setText("Paste text to count here");
		textArea.selectAll();	// set selection to remove next time

		textArea.addTextListener(new TextListener() {
				public void textValueChanged(TextEvent e) {
					//System.out.println("Text event");
					inputString = ((TextArea)e.getSource()).getText(); 
					//System.out.println(inputString);
					textArea_actionPerformed(e);
				}
		});
		textArea.addMouseListener(new MouseAdapter() {
				public void mouseReleased(MouseEvent event) {
					event.consume();
					// set caret to replace text on past
					try { textArea.setCaretPosition(0); }
					catch (IllegalArgumentException excp)
					{System.out.println("Illegal position");}
					textArea.selectAll();
				}
		});
		add(textArea);

		countLabel = new Label("Count:");
		add(countLabel);
		countTextField = new TextField();
		countTextField.setEditable(false);
		add(countTextField);

		Insets insets = getInsets();
		int row1y = 20;
		textArea.setBounds(25 + insets.left, row1y + insets.top, 300, 90);
		int row3y = 120;
		countLabel.setBounds(40 + insets.left, row3y + insets.top, 50, 20);
		countTextField.setBounds(100 + insets.left, row3y + insets.top, 100, 20);

		// setTitle("WordCount");
		setSize(375 + insets.left + insets.right,
						   175 + insets.top + insets.bottom);
		setVisible(true);
	} // init

	void textArea_actionPerformed(TextEvent e) {
		String text = inputString;
		int count = countWordsInString(text);
        String countstring = Integer.toString(count);
        countTextField.setText(countstring);
		//textArea.setText(text);
		textArea.selectAll();
	}	// textArea_actionPerformed

	/* This method accepts the name and location of a text file as
	input. It then counts the number of words in the file. */
	public int countWordsInString(String str)
	{
		StringTokenizer inStr = new StringTokenizer(str);
		String tempString;
		int count = 0;
		while(inStr.hasMoreTokens())
		{
			tempString = inStr.nextToken();
			if (tempString != "") {
				count++;
			}
		}
		return count;
	}	// countWordsInString()
}	// WordCountApplet

